--- /dev/null	Mon Nov 18 13:20:26 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/undef00.c	Mon Nov 18 13:20:26 2019
@@ -0,0 +1,21 @@
+static int badr(void)
+{
+	int *a;
+	return *a;
+}
+
+static void badw(int v)
+{
+	int *a;
+	*a = v;
+}
+
+/*
+ * check-name: undef00
+ * check-command: test-linearize -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-pattern(1): load\\.
+ * check-output-pattern(1): load\\..*\\[UNDEF\\]
+ * check-output-pattern(1): store\\.
+ * check-output-pattern(1): store\\..*\\[UNDEF\\]
+ */
--- /dev/null	Mon Nov 18 13:20:27 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/undef01.c	Mon Nov 18 13:20:27 2019
@@ -0,0 +1,16 @@
+static void foo(void)
+{
+	int *b;
+	for (;;)
+		*b++ = 0;
+}
+
+/*
+ * check-name: undef01
+ * check-command: sparse -Wmaybe-uninitialized $file
+ * check-known-to-fail
+ *
+ * check-error-start
+crazy04.c:3:13: warning: variable 'b' may be uninitialized
+ * check-error-end
+ */
--- /dev/null	Mon Nov 18 13:20:27 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/unused-var.c	Mon Nov 18 13:20:27 2019
@@ -0,0 +1,23 @@
+int foo(int a)
+{
+	switch (a) {
+		int u = 1;
+
+	default:
+		return a;
+	}
+}
+
+/*
+ * check-name: unused-var
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-start
+foo:
+.L0:
+	<entry-point>
+	ret.32      %arg1
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:27 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/volatile-store00.c	Mon Nov 18 13:20:27 2019
@@ -0,0 +1,27 @@
+void foo(volatile int *p)
+{
+	*p = 0;
+	*p = 0;
+}
+
+void bar(void)
+{
+	extern volatile int i;
+	i = 0;
+	i = 0;
+}
+
+
+void baz(void)
+{
+	volatile int i;
+	i = 0;
+	i = 0;
+}
+
+/*
+ * check-name: keep volatile stores
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-pattern(1,6): store\\.
+ */
--- old/usr/src/tools/smatch/src/validation/memops-volatile.c	Mon Nov 18 13:20:27 2019
+++ new/usr/src/tools/smatch/src/validation/memops-volatile.c	Mon Nov 18 13:20:27 2019
@@ -1,6 +1,7 @@
 static int foo(volatile int *a, int v)
 {
 	*a = v;
+	*a = 0;
 	return *a;
 }
 
@@ -8,14 +9,8 @@
  * check-name: memops-volatile
  * check-command: test-linearize $file
  *
- * check-output-start
-foo:
-.L0:
-	<entry-point>
-	store.32    %arg2 -> 0[%arg1]
-	load.32     %r5 <- 0[%arg1]
-	ret.32      %r5
-
-
- * check-output-end
+ * check-output-ignore
+ * check-output-contains: store\\..*%arg2 -> 0\\[%arg1]
+ * check-output-contains: store\\..*\\$0 -> 0\\[%arg1]
+ * check-output-contains: load\\..*%r.* <- 0\\[%arg1]
  */
--- /dev/null	Mon Nov 18 13:20:27 2019
+++ new/usr/src/tools/smatch/src/validation/missing-return.c	Mon Nov 18 13:20:27 2019
@@ -0,0 +1,20 @@
+int foo(int a)
+{
+}
+
+int bar(int a)
+{
+	if (a)
+		return 0;
+}
+
+/*
+ * check-name: missing return
+ * check-command: sparse -Wno-decl $file
+ * check-known-to-fail
+ *
+ * check-error-start
+missing-return.c:3:1: warning: control reaches end of non-void function
+missing-return.c:9:1: warning: control reaches end of non-void function
+ * check-error-end
+ */
--- /dev/null	Mon Nov 18 13:20:27 2019
+++ new/usr/src/tools/smatch/src/validation/multi-input.c	Mon Nov 18 13:20:27 2019
@@ -0,0 +1,11 @@
+int a = 1;
+int foo(void) {}
+
+static int b = 1;
+static int bar(void) {}
+
+/*
+ * check-name: multi-input
+ * check-command: sparse -Wno-decl $file $file
+ * check-known-to-fail
+ */
--- old/usr/src/tools/smatch/src/validation/nested-declarator.c	Mon Nov 18 13:20:28 2019
+++ new/usr/src/tools/smatch/src/validation/nested-declarator.c	Mon Nov 18 13:20:28 2019
@@ -15,7 +15,7 @@
 int j(int [2](*));
 /*
  * check-name: nested declarator vs. parameters
- * check-error-start:
+ * check-error-start
 nested-declarator.c:11:23: warning: missing identifier in declaration
 nested-declarator.c:11:23: error: Expected ; at the end of type declaration
 nested-declarator.c:11:23: error: got (
@@ -25,5 +25,5 @@
 nested-declarator.c:14:18: error: got (
 nested-declarator.c:15:14: error: Expected ) in function declarator
 nested-declarator.c:15:14: error: got (
- * check-error-end:
+ * check-error-end
  */
--- old/usr/src/tools/smatch/src/validation/nested-declarator2.c	Mon Nov 18 13:20:28 2019
+++ new/usr/src/tools/smatch/src/validation/nested-declarator2.c	Mon Nov 18 13:20:28 2019
@@ -27,7 +27,7 @@
 static void [2](*bad3);
 /*
  * check-name: more on handling of ( in direct-declarator
- * check-error-start:
+ * check-error-start
 nested-declarator2.c:17:1: warning: non-ANSI definition of function 'w1'
 nested-declarator2.c:21:21: warning: non-ANSI function declaration of function '<noident>'
 nested-declarator2.c:22:16: warning: variadic functions must have one named argument
@@ -37,5 +37,5 @@
 nested-declarator2.c:26:13: error: got -
 nested-declarator2.c:27:16: error: Expected ; at the end of type declaration
 nested-declarator2.c:27:16: error: got (
- * check-error-end:
+ * check-error-end
  */
--- old/usr/src/tools/smatch/src/validation/nocast.c	Mon Nov 18 13:20:28 2019
+++ new/usr/src/tools/smatch/src/validation/nocast.c	Mon Nov 18 13:20:28 2019
@@ -160,7 +160,7 @@
 nocast.c:34:33: warning: implicit cast to nocast type
 nocast.c:35:39: warning: incorrect type in initializer (different modifiers)
 nocast.c:35:39:    expected unsigned long *static [toplevel] bad_ptr_from
-nocast.c:35:39:    got unsigned long [nocast] *<noident>
+nocast.c:35:39:    got unsigned long [nocast] *
 nocast.c:35:39: warning: implicit cast from nocast type
 nocast.c:50:16: warning: implicit cast from nocast type
 nocast.c:54:16: warning: implicit cast from nocast type
--- old/usr/src/tools/smatch/src/validation/noderef.c	Mon Nov 18 13:20:29 2019
+++ new/usr/src/tools/smatch/src/validation/noderef.c	Mon Nov 18 13:20:29 2019
@@ -46,6 +46,6 @@
  * check-error-start
 noderef.c:24:12: warning: incorrect type in assignment (different modifiers)
 noderef.c:24:12:    expected char *[noderef] *q2
-noderef.c:24:12:    got char [noderef] **<noident>
+noderef.c:24:12:    got char [noderef] **
  * check-error-end
  */
--- /dev/null	Mon Nov 18 13:20:29 2019
+++ new/usr/src/tools/smatch/src/validation/optim/address-used01.c	Mon Nov 18 13:20:29 2019
@@ -0,0 +1,18 @@
+int foo(int **g, int j)
+{
+	int i = 1;
+	int *a;
+	int **p;
+
+	a = &i;
+	p = &a;
+	*p[0] = 0;
+	return i;
+}
+
+/*
+ * check-name: address-used01
+ * check-command: test-linearize -Wno-decl -fdump-ir=final $file
+ * check-output-ignore
+ * check-output-contains: ret\\..* \\$0
+ */
--- /dev/null	Mon Nov 18 13:20:29 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-extend.c	Mon Nov 18 13:20:29 2019
@@ -0,0 +1,27 @@
+typedef unsigned short u16;
+typedef          short s16;
+typedef unsigned   int u32;
+typedef            int s32;
+
+u32 ufoo(u32 x)
+{
+	u16 i = ((u16)x) & 0x7fffU;
+	return i;
+}
+
+u32 sfoo(u32 x)
+{
+	s16 i = ((s16)x) & 0x7fff;
+	return i;
+}
+
+/*
+ * check-name: and-extend
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: trunc\\.
+ * check-output-excludes: zext\\.
+ * check-output-excludes: sext\\.
+ * check-output-contains: and\\.32.*0x7fff
+ */
--- /dev/null	Mon Nov 18 13:20:29 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-extendx.c	Mon Nov 18 13:20:29 2019
@@ -0,0 +1,24 @@
+typedef unsigned short u16;
+typedef          short s16;
+typedef unsigned   int u32;
+typedef            int s32;
+typedef unsigned  long long u64;
+typedef           long long s64;
+
+u64 ufoo(int x)
+{
+	return x & 0x7fff;
+}
+
+u64 sfoo(int x)
+{
+	return x & 0x7fff;
+}
+
+/*
+ * check-name: and-extend
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: and\\.64.*0x7fff
+ */
--- /dev/null	Mon Nov 18 13:20:29 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-lsr.c	Mon Nov 18 13:20:29 2019
@@ -0,0 +1,15 @@
+// (x & M) >> S to (x >> S) & (M >> S)
+
+unsigned int foo(unsigned int x)
+{
+	return (x & 0xffff) >> 12;
+}
+
+/*
+ * check-name: and-lsr
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: and\\..*\\$15
+ * check-output-excludes: and\\..*\\$0xffff
+ */
--- /dev/null	Mon Nov 18 13:20:29 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-bf0.c	Mon Nov 18 13:20:29 2019
@@ -0,0 +1,24 @@
+struct s {
+	int f:3;
+};
+
+void foo(struct s *p, int a)
+{
+	p->f = 1;
+	p->f = a;
+}
+
+void bar(struct s *p, int a)
+{
+	p->f = a;
+	p->f = 1;
+}
+
+/*
+ * check-name: and-or-bf0
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(3): and\\.
+ * check-output-pattern(2): or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:30 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-bf1.c	Mon Nov 18 13:20:30 2019
@@ -0,0 +1,18 @@
+struct s {
+	int  :2;
+	int f:3;
+};
+
+void foo(struct s *d, const struct s *s, int a)
+{
+	d->f = s->f | a;
+}
+
+/*
+ * check-name: and-or-bf1
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(2): and\\.
+ * check-output-pattern(2): or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:30 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-bf2.c	Mon Nov 18 13:20:30 2019
@@ -0,0 +1,27 @@
+struct s {
+	char a:3;
+	char b:3;
+	char c:2;
+};
+
+void foo(struct s *p)
+{
+	p->a = 1;
+	p->b = 2;
+	p->c = 3;
+}
+
+/*
+ * check-name: and-or-bf2
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-start
+foo:
+.L0:
+	<entry-point>
+	store.8     $209 -> 0[%arg1]
+	ret
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:30 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-bfs.c	Mon Nov 18 13:20:30 2019
@@ -0,0 +1,23 @@
+struct s {
+	  signed int  :2;
+	  signed int f:3;
+};
+
+int bfs(struct s s, int a)
+{
+	s.f = a;
+	return s.f;
+}
+
+/*
+ * check-name: and-or-bfs
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(1): trunc\\.
+ * check-output-pattern(1): sext\\.
+ * check-output-excludes: and\\.
+ * check-output-excludes: or\\.
+ * check-output-excludes: shl\\.
+ * check-output-excludes: lsr\\.
+ */
--- /dev/null	Mon Nov 18 13:20:30 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-bfu.c	Mon Nov 18 13:20:30 2019
@@ -0,0 +1,21 @@
+struct u {
+	unsigned int  :2;
+	unsigned int f:3;
+};
+
+int bfu(struct u s, int a)
+{
+	s.f = a;
+	return s.f;
+}
+
+/*
+ * check-name: and-or-bfu
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(1): and\\.
+ * check-output-excludes: or\\.
+ * check-output-excludes: shl\\.
+ * check-output-excludes: lsr\\.
+ */
--- /dev/null	Mon Nov 18 13:20:30 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-bfx.c	Mon Nov 18 13:20:30 2019
@@ -0,0 +1,18 @@
+struct s {
+	int f:3;
+};
+
+void foo(struct s *p, int a, int b)
+{
+	p->f = a;
+	p->f = b;
+}
+
+/*
+ * check-name: and-or-bfx
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(2): and\\.
+ * check-output-pattern(1): or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:30 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-constant0.c	Mon Nov 18 13:20:30 2019
@@ -0,0 +1,12 @@
+int foo(int x)
+{
+	return (x | 0xfffff000) & 0xfff;
+}
+
+/*
+ * check-name: and-or-constant0
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:30 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-constant1.c	Mon Nov 18 13:20:30 2019
@@ -0,0 +1,14 @@
+int foo(int x)
+{
+	return (x | 0x000fffff) & 0xfff;
+}
+
+/*
+ * check-name: or-and-constant1
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: ret\\..*\\$0xfff
+ * check-output-excludes: and\\.
+ * check-output-excludes: or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:31 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-constant2.c	Mon Nov 18 13:20:31 2019
@@ -0,0 +1,13 @@
+int foo(int x)
+{
+	return (x | 0xfffffff0) & 0xfff;
+}
+
+/*
+ * check-name: and-or-constant2
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: or\\..*\\$0xff0
+ * check-output-excludes: or\\..*\\$0xfffffff0
+ */
--- /dev/null	Mon Nov 18 13:20:31 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-crash.c	Mon Nov 18 13:20:31 2019
@@ -0,0 +1,5 @@
+static unsigned a(unsigned b, unsigned c) { (c << 1 | b & 1 << 1) >> 1; }
+
+/*
+ * check-name: catch crashes during AND-OR simplifications
+ */
--- /dev/null	Mon Nov 18 13:20:31 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-lsr0.c	Mon Nov 18 13:20:31 2019
@@ -0,0 +1,13 @@
+int foo(int a, int b)
+{
+	return ((a & 0x00000fff) | b) >> 12;
+}
+
+/*
+ * check-name: and-or-lsr0
+ * check-command: test-linearize -Wno-decl $file
+ * check-known-to-fail
+ *
+ * check-output-ignore
+ * check-output-excludes: or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:31 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-lsr1.c	Mon Nov 18 13:20:31 2019
@@ -0,0 +1,13 @@
+int foo(int a, int b)
+{
+	return ((a & 0xfffff000) | b) >> 12;
+}
+
+/*
+ * check-name: and-or-lsr1
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(0): and\\.
+ * check-output-pattern(1): or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:31 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-lsr2.c	Mon Nov 18 13:20:31 2019
@@ -0,0 +1,13 @@
+int foo(int x, int y)
+{
+	return ((x & 0xf0ffffff) | y) >> 12;
+}
+
+/*
+ * check-name: and-or-lsr2
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: and\\..*\\$0xf0fff
+ * check-output-excludes: and\\..*\\$0xf0ffffff
+ */
--- /dev/null	Mon Nov 18 13:20:31 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-lsrx.c	Mon Nov 18 13:20:31 2019
@@ -0,0 +1,13 @@
+unsigned int foo(unsigned int x, unsigned int y, unsigned int a)
+{
+	return ((x & y) | (a & 0x0fff)) >> 12;
+}
+
+/*
+ * check-name: and-or-lsrx
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(1): and\\.
+ * check-output-excludes: or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:31 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-mask.c	Mon Nov 18 13:20:31 2019
@@ -0,0 +1,18 @@
+int foo(int a, int b)
+{
+	return ((a & 7) | (b & 3)) & 8;
+}
+
+/*
+ * check-name: and-or-mask
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-start
+foo:
+.L0:
+	<entry-point>
+	ret.32      $0
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:32 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-mask0.c	Mon Nov 18 13:20:32 2019
@@ -0,0 +1,12 @@
+int foo(int a, int b)
+{
+	return ((a & 0xfffff000) | b) & 0xfff;
+}
+
+/*
+ * check-name: and-or-mask0
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:32 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-mask1.c	Mon Nov 18 13:20:32 2019
@@ -0,0 +1,13 @@
+int foo(int a, int b)
+{
+	return ((a & 0x0fffffff) | b) & 0xfff;
+}
+
+/*
+ * check-name: and-or-mask1
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(1): and\\.
+ * check-output-pattern(1): or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:32 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-mask2.c	Mon Nov 18 13:20:32 2019
@@ -0,0 +1,13 @@
+int foo(int x, int y)
+{
+	return ((x & 0xffffff0f) | y) & 0xfff;
+}
+
+/*
+ * check-name: and-or-mask2
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: and\\..*\\$0xf0f
+ * check-output-excludes: and\\..*\\$0xffffff0f
+ */
--- /dev/null	Mon Nov 18 13:20:32 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-mask3s.c	Mon Nov 18 13:20:32 2019
@@ -0,0 +1,25 @@
+#define W	3
+#define	S	8
+#define M	(W << S)
+
+static inline int fun(unsigned int x, unsigned int y)
+{
+	return ((x & M) | (y << S)) >> S;
+}
+
+short foo(unsigned int x, unsigned int y)
+{
+	return fun(x, y) & W;
+}
+
+/*
+ * check-name: and-or-mask3s
+ * check-command: test-linearize -Wno-decl $file
+ * check-known-to-fail
+ *
+ * check-output-ignore
+ * check-output-pattern(1): lsr\\.
+ * check-output-pattern(1): or\\.
+ * check-output-pattern(1): and\\.
+ * check-output-excludes: shl\\.
+ */
--- /dev/null	Mon Nov 18 13:20:32 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-mask3u.c	Mon Nov 18 13:20:32 2019
@@ -0,0 +1,25 @@
+#define W	3
+#define	S	8
+#define M	(W << S)
+
+static inline int fun(unsigned int x, unsigned int y)
+{
+	return ((x & M) | (y << S)) >> S;
+}
+
+int foo(unsigned int x, unsigned int y)
+{
+	return fun(x, y) & W;
+}
+
+/*
+ * check-name: and-or-mask3u
+ * check-command: test-linearize -Wno-decl $file
+ * check-known-to-fail
+ *
+ * check-output-ignore
+ * check-output-pattern(1): lsr\\.
+ * check-output-pattern(1): or\\.
+ * check-output-pattern(1): and\\.
+ * check-output-excludes: shl\\.
+ */
--- /dev/null	Mon Nov 18 13:20:32 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-mask4.c	Mon Nov 18 13:20:32 2019
@@ -0,0 +1,25 @@
+#define W	3
+#define	S	8
+#define M	(W << S)
+
+static inline int fun(unsigned int x, unsigned int y)
+{
+	return ((x & W) | (y >> S)) << S;
+}
+
+int foo(unsigned int x, unsigned int y)
+{
+	return fun(x, y) & M;
+}
+
+/*
+ * check-name: and-or-mask4
+ * check-command: test-linearize -Wno-decl $file
+ * check-known-to-fail
+ *
+ * check-output-ignore
+ * check-output-pattern(1): shl\\.
+ * check-output-pattern(1): or\\.
+ * check-output-pattern(1): and\\.
+ * check-output-excludes: lsr\\.
+ */
--- /dev/null	Mon Nov 18 13:20:32 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-maskx.c	Mon Nov 18 13:20:32 2019
@@ -0,0 +1,13 @@
+int foo(int x, int y, int a)
+{
+	return ((x & y) | (a & 0xf000)) & 0x0fff;
+}
+
+/*
+ * check-name: and-or-maskx
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(2): and\\.
+ * check-output-excludes: or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:33 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-shl0.c	Mon Nov 18 13:20:33 2019
@@ -0,0 +1,12 @@
+int foo(int a, int b)
+{
+	return ((a & 0xfff00000) | b) << 12;
+}
+
+/*
+ * check-name: and-or-shl0
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:33 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-shl1.c	Mon Nov 18 13:20:33 2019
@@ -0,0 +1,13 @@
+int foo(int a, int b)
+{
+	return ((a & 0x000fffff) | b) << 12;
+}
+
+/*
+ * check-name: and-or-shl1
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(0): and\\.
+ * check-output-pattern(1): or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:33 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-shl2.c	Mon Nov 18 13:20:33 2019
@@ -0,0 +1,13 @@
+int foo(int x, int y)
+{
+	return ((x & 0xffffff0f) | y) << 12;
+}
+
+/*
+ * check-name: and-or-shl2
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: and\\..*\\$0xfff0f
+ * check-output-excludes: and\\..*\\$0xffffff0f
+ */
--- /dev/null	Mon Nov 18 13:20:33 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-shlx.c	Mon Nov 18 13:20:33 2019
@@ -0,0 +1,13 @@
+unsigned int foo(unsigned int x, unsigned int y, unsigned int a)
+{
+	return ((x & y) | (a & 0xfff00000)) << 12;
+}
+
+/*
+ * check-name: and-or-shlx
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(1): and\\.
+ * check-output-excludes: or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:33 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-trunc0.c	Mon Nov 18 13:20:33 2019
@@ -0,0 +1,13 @@
+char foo(int x, int y)
+{
+	return (x & 0xff00) | y;
+}
+
+/*
+ * check-name: and-or-trunc0
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: and\\.
+ * check-output-excludes: or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:33 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-trunc1.c	Mon Nov 18 13:20:33 2019
@@ -0,0 +1,12 @@
+char foo(int x, int y)
+{
+	return (x & 0xffff) | y;
+}
+
+/*
+ * check-name: and-or-trunc1
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: and\\.
+ */
--- /dev/null	Mon Nov 18 13:20:34 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-trunc2.c	Mon Nov 18 13:20:34 2019
@@ -0,0 +1,13 @@
+char foo(int x, int y)
+{
+	return (x & 0xff07) | y;
+}
+
+/*
+ * check-name: and-or-trunc2
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(1): and\\.
+ * check-output-pattern(1): and\\..*\\$7
+ */
--- /dev/null	Mon Nov 18 13:20:34 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-or-truncx.c	Mon Nov 18 13:20:34 2019
@@ -0,0 +1,13 @@
+char foo(int x, int y, int b)
+{
+	return (x & y) | (b & 0xff00);
+}
+
+/*
+ * check-name: and-or-truncx
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(1): and\\.
+ * check-output-excludes: or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:34 2019
+++ new/usr/src/tools/smatch/src/validation/optim/and-trunc.c	Mon Nov 18 13:20:34 2019
@@ -0,0 +1,20 @@
+short smask(short x)
+{
+	return x & (short) 0x7fff;
+}
+
+short umask(unsigned short x)
+{
+	return x & (unsigned short) 0x7fff;
+}
+
+/*
+ * check-name: and-trunc
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: sext\\.
+ * check-output-excludes: zext\\.
+ * check-output-excludes: trunc\\.
+ * check-output-contains: and\\.16
+ */
--- /dev/null	Mon Nov 18 13:20:34 2019
+++ new/usr/src/tools/smatch/src/validation/optim/bitfield-init-zero.c	Mon Nov 18 13:20:34 2019
@@ -0,0 +1,102 @@
+struct bfu {
+	unsigned int a:11;
+	unsigned int f:9;
+	unsigned int  :2;
+	unsigned int z:3;
+};
+
+struct bfu bfuu_init(unsigned int a)
+{
+	struct bfu bf = { .f = a, };
+	return bf;
+}
+
+struct bfu bfus_init(int a)
+{
+	struct bfu bf = { .f = a, };
+	return bf;
+}
+
+unsigned int bfu_get0(void)
+{
+	struct bfu bf = { };
+	return bf.f;
+}
+
+
+struct bfs {
+	signed int a:11;
+	signed int f:9;
+	signed int  :2;
+	signed int z:3;
+};
+
+struct bfs bfsu_init(unsigned int a)
+{
+	struct bfs bf = { .f = a, };
+	return bf;
+}
+
+struct bfs bfss_init(int a)
+{
+	struct bfs bf = { .f = a, };
+	return bf;
+}
+
+int bfs_get0(void)
+{
+	struct bfs bf = { };
+	return bf.f;
+}
+
+/*
+ * check-name: bitfield implicit init zero
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-start
+bfuu_init:
+.L0:
+	<entry-point>
+	and.32      %r4 <- %arg1, $511
+	shl.32      %r5 <- %r4, $11
+	ret.32      %r5
+
+
+bfus_init:
+.L2:
+	<entry-point>
+	and.32      %r13 <- %arg1, $511
+	shl.32      %r14 <- %r13, $11
+	ret.32      %r14
+
+
+bfu_get0:
+.L4:
+	<entry-point>
+	ret.32      $0
+
+
+bfsu_init:
+.L6:
+	<entry-point>
+	and.32      %r27 <- %arg1, $511
+	shl.32      %r28 <- %r27, $11
+	ret.32      %r28
+
+
+bfss_init:
+.L8:
+	<entry-point>
+	and.32      %r36 <- %arg1, $511
+	shl.32      %r37 <- %r36, $11
+	ret.32      %r37
+
+
+bfs_get0:
+.L10:
+	<entry-point>
+	ret.32      $0
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:34 2019
+++ new/usr/src/tools/smatch/src/validation/optim/bitfield-size.c	Mon Nov 18 13:20:34 2019
@@ -0,0 +1,44 @@
+struct bfu {
+	unsigned int a:4;
+	unsigned int  :2;
+	unsigned int b:4;
+};
+unsigned int get__bfu_a(struct bfu bf) { return bf.a; }
+unsigned int get__bfu_b(struct bfu bf) { return bf.b; }
+unsigned int get_pbfu_a(struct bfu *bf) { return bf->a; }
+unsigned int get_pbfu_b(struct bfu *bf) { return bf->b; }
+
+
+struct bfs {
+	signed int a:4;
+	signed int  :2;
+	signed int b:4;
+};
+signed int get__bfs_a(struct bfs bf) { return bf.a; }
+signed int get__bfs_b(struct bfs bf) { return bf.b; }
+signed int get_pbfs_a(struct bfs *bf) { return bf->a; }
+signed int get_pbfs_b(struct bfs *bf) { return bf->b; }
+
+
+struct bfi {
+	int a:4;
+	int  :2;
+	int b:4;
+};
+unsigned int get__bfi_a(struct bfi bf) { return bf.a; }
+unsigned int get__bfi_b(struct bfi bf) { return bf.b; }
+unsigned int get_pbfi_a(struct bfi *bf) { return bf->a; }
+unsigned int get_pbfi_b(struct bfi *bf) { return bf->b; }
+
+/*
+ * check-name: bitfield size
+ * check-command: test-linearize -Wno-decl $file
+ * check-output-ignore
+ *
+ * check-output-excludes: and\\..*\\$960
+ * check-output-excludes: zext\\.
+ * check-output-pattern(8): and\\..*\\$15
+ * check-output-pattern(4): sext\\.
+ * check-output-pattern(4): trunc\\.4
+ * check-output-pattern(6): lsr\\..*\\$6
+ */
--- /dev/null	Mon Nov 18 13:20:35 2019
+++ new/usr/src/tools/smatch/src/validation/optim/bitfield-store-load0.c	Mon Nov 18 13:20:35 2019
@@ -0,0 +1,44 @@
+int ufoo(unsigned int a)
+{
+	struct u {
+		unsigned int :2;
+		unsigned int a:3;
+	} bf;
+
+	bf.a = a;
+	return bf.a;
+}
+
+int sfoo(int a)
+{
+	struct s {
+		signed int :2;
+		signed int a:3;
+	} bf;
+
+	bf.a = a;
+	return bf.a;
+}
+
+/*
+ * check-name: optim store/load bitfields
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-start
+ufoo:
+.L0:
+	<entry-point>
+	and.32      %r11 <- %arg1, $7
+	ret.32      %r11
+
+
+sfoo:
+.L2:
+	<entry-point>
+	trunc.3     %r16 <- (32) %arg1
+	sext.32     %r23 <- (3) %r16
+	ret.32      %r23
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:35 2019
+++ new/usr/src/tools/smatch/src/validation/optim/bitfield-store-loads.c	Mon Nov 18 13:20:35 2019
@@ -0,0 +1,23 @@
+struct s {
+	char :2;
+	char f:3;
+};
+
+int foo(struct s s, int a)
+{
+	s.f = a;
+	return s.f;
+}
+
+/*
+ * check-name: bitfield-store-load signed
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: shl\\.
+ * check-output-excludes: lsr\\.
+ * check-output-excludes: or\\.
+ * check-output-excludes: [sz]ext\\.
+ * check-output-excludes: trunc\\.
+ * check-output-pattern(1): and\\.
+ */
--- /dev/null	Mon Nov 18 13:20:35 2019
+++ new/usr/src/tools/smatch/src/validation/optim/bitfield-store-loadu.c	Mon Nov 18 13:20:35 2019
@@ -0,0 +1,21 @@
+struct s {
+	unsigned int :2;
+	unsigned int f:3;
+};
+
+int foo(struct s s, int a)
+{
+	s.f = a;
+	return s.f;
+}
+
+/*
+ * check-name: bitfield-store-load unsigned
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: shl\\.
+ * check-output-excludes: lsr\\.
+ * check-output-excludes: or\\.
+ * check-output-pattern(1): and\\.
+ */
--- /dev/null	Mon Nov 18 13:20:35 2019
+++ new/usr/src/tools/smatch/src/validation/optim/bits-not-zero.c	Mon Nov 18 13:20:35 2019
@@ -0,0 +1,30 @@
+int  or_not0(int a) { return a | ~0; }
+int and_not0(int a) { return a & ~0; }
+int xor_not0(int a) { return a ^ ~0; }
+
+/*
+ * check-name: bool-not-zero
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-start
+or_not0:
+.L0:
+	<entry-point>
+	ret.32      $0xffffffff
+
+
+and_not0:
+.L2:
+	<entry-point>
+	ret.32      %arg1
+
+
+xor_not0:
+.L4:
+	<entry-point>
+	not.32      %r8 <- %arg1
+	ret.32      %r8
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:35 2019
+++ new/usr/src/tools/smatch/src/validation/optim/bool-context-fp.c	Mon Nov 18 13:20:35 2019
@@ -0,0 +1,93 @@
+#define	bool	_Bool
+
+bool bfimp(float a) { return a; }
+bool bfexp(float a) { return (bool)a; }
+
+bool bfnot(float a) { return !a; }
+int  ifnot(float a) { return !a; }
+bool bfior(float a, float b) { return a || b; }
+int  ifior(float a, float b) { return a || b; }
+bool bfand(float a, float b) { return a && b; }
+int  ifand(float a, float b) { return a && b; }
+
+/*
+ * check-name: bool context fp
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-start
+bfimp:
+.L0:
+	<entry-point>
+	setfval.32  %r2 <- 0.000000e+00
+	fcmpune.1   %r3 <- %arg1, %r2
+	ret.1       %r3
+
+
+bfexp:
+.L2:
+	<entry-point>
+	setfval.32  %r6 <- 0.000000e+00
+	fcmpune.1   %r7 <- %arg1, %r6
+	ret.1       %r7
+
+
+bfnot:
+.L4:
+	<entry-point>
+	setfval.32  %r10 <- 0.000000e+00
+	fcmpoeq.1   %r12 <- %arg1, %r10
+	ret.1       %r12
+
+
+ifnot:
+.L6:
+	<entry-point>
+	setfval.32  %r15 <- 0.000000e+00
+	fcmpoeq.32  %r16 <- %arg1, %r15
+	ret.32      %r16
+
+
+bfior:
+.L8:
+	<entry-point>
+	setfval.32  %r19 <- 0.000000e+00
+	fcmpune.1   %r20 <- %arg1, %r19
+	fcmpune.1   %r23 <- %arg2, %r19
+	or.1        %r24 <- %r20, %r23
+	ret.1       %r24
+
+
+ifior:
+.L10:
+	<entry-point>
+	setfval.32  %r29 <- 0.000000e+00
+	fcmpune.1   %r30 <- %arg1, %r29
+	fcmpune.1   %r33 <- %arg2, %r29
+	or.1        %r34 <- %r30, %r33
+	zext.32     %r35 <- (1) %r34
+	ret.32      %r35
+
+
+bfand:
+.L12:
+	<entry-point>
+	setfval.32  %r38 <- 0.000000e+00
+	fcmpune.1   %r39 <- %arg1, %r38
+	fcmpune.1   %r42 <- %arg2, %r38
+	and.1       %r43 <- %r39, %r42
+	ret.1       %r43
+
+
+ifand:
+.L14:
+	<entry-point>
+	setfval.32  %r48 <- 0.000000e+00
+	fcmpune.1   %r49 <- %arg1, %r48
+	fcmpune.1   %r52 <- %arg2, %r48
+	and.1       %r53 <- %r49, %r52
+	zext.32     %r54 <- (1) %r53
+	ret.32      %r54
+
+
+ * check-output-end
+ */
--- old/usr/src/tools/smatch/src/validation/optim/bool-context.c	Mon Nov 18 13:20:35 2019
+++ new/usr/src/tools/smatch/src/validation/optim/bool-context.c	Mon Nov 18 13:20:36 2019
@@ -8,5 +8,5 @@
  * check-command: test-linearize -Wno-decl $file
  * check-output-ignore
  *
- * check-output-pattern-4-times: setne\\..* %arg[12]
+ * check-output-pattern(4): setne\\..* %arg[12]
  */
--- /dev/null	Mon Nov 18 13:20:36 2019
+++ new/usr/src/tools/smatch/src/validation/optim/bool-eq0.c	Mon Nov 18 13:20:36 2019
@@ -0,0 +1,12 @@
+int beq0(int a) { return a == 0; }
+int bnotne0(int a) { return !(a != 0); }
+int bnot(int a) { return !a; }
+
+/*
+ * check-name: bool-eq0
+ * check-command: test-linearize -Wno-decl $file
+ * check-output-ignore
+ *
+ * check-output-excludes: setne\\.
+ * check-output-contains: seteq\\.
+ */
--- /dev/null	Mon Nov 18 13:20:36 2019
+++ new/usr/src/tools/smatch/src/validation/optim/bool-int-bool.c	Mon Nov 18 13:20:36 2019
@@ -0,0 +1,12 @@
+_Bool beq0(_Bool a) { return (a == 0); }
+_Bool beq1(_Bool a) { return (a == 1); }
+_Bool bne0(_Bool a) { return (a != 0); }
+_Bool bne1(_Bool a) { return (a != 1); }
+
+/*
+ * check-name: bool - int - bool constants
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: cast\\.
+ */
--- /dev/null	Mon Nov 18 13:20:36 2019
+++ new/usr/src/tools/smatch/src/validation/optim/bool-ne0.c	Mon Nov 18 13:20:36 2019
@@ -0,0 +1,12 @@
+int bne0(int a) { return a != 0; }
+int bnoteq0(int a) { return !(a == 0); }
+int bnotnot(int a) { return !(!a); }
+
+/*
+ * check-name: bool-ne0
+ * check-command: test-linearize -Wno-decl $file
+ * check-output-ignore
+ *
+ * check-output-excludes: seteq\\.
+ * check-output-contains: setne\\.
+ */
--- /dev/null	Mon Nov 18 13:20:36 2019
+++ new/usr/src/tools/smatch/src/validation/optim/bool-neq0.c	Mon Nov 18 13:20:36 2019
@@ -0,0 +1,12 @@
+int bneq0(int a) { return a != 0; }
+int bnoteq0(int a) { return !(a == 0); }
+int bnotnot(int a) { return !(!a); }
+
+/*
+ * check-name: bool-neq0
+ * check-command: test-linearize -Wno-decl $file
+ * check-output-ignore
+ *
+ * check-output-excludes: seteq\\.
+ * check-output-contains: setne\\.
+ */
